#include "utils/Utility.h"

static Core::ExitHandler exitHandler = nullptr;
static void* exitData = nullptr;

void* operator new(size_t bytes) noexcept {
    return malloc(bytes);
}

void* operator new[](size_t bytes) noexcept {
    return malloc(bytes);
}

void operator delete(void* p) noexcept {
    free(p);
}

void operator delete[](void* p) noexcept {
    free(p);
}

void operator delete(void* p, size_t bytes) noexcept {
    (void)bytes;
    free(p);
}

void operator delete[](void* p, size_t bytes) noexcept {
    (void)bytes;
    free(p);
}

void* operator new(size_t bytes, void* p) noexcept {
    (void)bytes;
    return p;
}

/*void* operator new[](size_t bytes, void* p) noexcept {
    (void)bytes;
    return p;
}*/

void Core::exitWithHandler(int value) {
    if(exitHandler != nullptr) {
        exitHandler(value, exitData);
    }
    exit(value);
}

void Core::setExitHandler(ExitHandler eh, void* data) {
    exitHandler = eh;
    exitData = data;
}